<html>
<head>
<title>OgreSerializer.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreSerializer.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreSerializer_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __Serializer_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __Serializer_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreString_8h.html">OgreString.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreDataStream_8h.html">OgreDataStream.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>Ogre {
<a name="l00037"></a>00037 
<a name="l00049"></a><a class="code" href="classOgre_1_1Serializer.html">00049</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Serializer.html" title="Generic class for serialising data to / from binary stream-based files.">Serializer</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">SerializerAlloc</a>
<a name="l00050"></a>00050     {
<a name="l00051"></a>00051     <span class="keyword">public</span>:
<a name="l00052"></a>00052         <a class="code" href="classOgre_1_1Serializer.html" title="Generic class for serialising data to / from binary stream-based files.">Serializer</a>();
<a name="l00053"></a>00053         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1Serializer.html" title="Generic class for serialising data to / from binary stream-based files.">Serializer</a>();
<a name="l00054"></a>00054 
<a name="l00056"></a><a class="code" href="classOgre_1_1Serializer.html#a5122d5a3161fb5fd819d9a0521fe9d39">00056</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1Serializer.html#a5122d5a3161fb5fd819d9a0521fe9d39" title="The endianness of written files.">Endian</a>
<a name="l00057"></a>00057         {
<a name="l00059"></a><a class="code" href="classOgre_1_1Serializer.html#a5122d5a3161fb5fd819d9a0521fe9d39aed60ca999861d8939cf57f19090c70ef">00059</a>             <a class="code" href="classOgre_1_1Serializer.html#a5122d5a3161fb5fd819d9a0521fe9d39aed60ca999861d8939cf57f19090c70ef" title="Use the platform native endian.">ENDIAN_NATIVE</a>,
<a name="l00061"></a><a class="code" href="classOgre_1_1Serializer.html#a5122d5a3161fb5fd819d9a0521fe9d39a7f044c7683a7374276db6e7060f51240">00061</a>             <a class="code" href="classOgre_1_1Serializer.html#a5122d5a3161fb5fd819d9a0521fe9d39a7f044c7683a7374276db6e7060f51240" title="Use big endian (0x1000 is serialised as 0x10 0x00)">ENDIAN_BIG</a>,
<a name="l00063"></a><a class="code" href="classOgre_1_1Serializer.html#a5122d5a3161fb5fd819d9a0521fe9d39a10ce3b8f55cba526f6bc8237d8b25cc3">00063</a>             ENDIAN_LITTLE
<a name="l00064"></a>00064         };
<a name="l00065"></a>00065 
<a name="l00066"></a>00066 
<a name="l00067"></a>00067     <span class="keyword">protected</span>:
<a name="l00068"></a>00068 
<a name="l00069"></a><a class="code" href="classOgre_1_1Serializer.html#a6331ceec847b83fed77165c9522eaa4f">00069</a>         <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> <a class="code" href="classOgre_1_1Serializer.html#a6331ceec847b83fed77165c9522eaa4f">mCurrentstreamLen</a>;
<a name="l00070"></a><a class="code" href="classOgre_1_1Serializer.html#a9e1a15f67a59822b2a0fe3afceea0a9d">00070</a>         <a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a> <a class="code" href="classOgre_1_1Serializer.html#a9e1a15f67a59822b2a0fe3afceea0a9d">mStream</a>;
<a name="l00071"></a><a class="code" href="classOgre_1_1Serializer.html#a45b8d6fa3d3c64b3ab3dfe3a5084e3b4">00071</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1Serializer.html#a45b8d6fa3d3c64b3ab3dfe3a5084e3b4">mVersion</a>;
<a name="l00072"></a><a class="code" href="classOgre_1_1Serializer.html#aa0773a2ca956fa2864ac50f57d0aa9a2">00072</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Serializer.html#aa0773a2ca956fa2864ac50f57d0aa9a2">mFlipEndian</a>; <span class="comment">// default to native endian, derive from header</span>
<a name="l00073"></a>00073 
<a name="l00074"></a>00074         <span class="comment">// Internal methods</span>
<a name="l00075"></a>00075         <span class="keyword">virtual</span> <span class="keywordtype">void</span> writeFileHeader(<span class="keywordtype">void</span>);
<a name="l00076"></a>00076         <span class="keyword">virtual</span> <span class="keywordtype">void</span> writeChunkHeader(<a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> <span class="keywordtype">id</span>, <span class="keywordtype">size_t</span> size);
<a name="l00077"></a>00077         
<a name="l00078"></a>00078         <span class="keywordtype">void</span> writeFloats(<span class="keyword">const</span> <span class="keywordtype">float</span>* <span class="keyword">const</span> pfloat, <span class="keywordtype">size_t</span> count);
<a name="l00079"></a>00079         <span class="keywordtype">void</span> writeFloats(<span class="keyword">const</span> <span class="keywordtype">double</span>* <span class="keyword">const</span> pfloat, <span class="keywordtype">size_t</span> count);
<a name="l00080"></a>00080         <span class="keywordtype">void</span> writeShorts(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a>* <span class="keyword">const</span> pShort, <span class="keywordtype">size_t</span> count);
<a name="l00081"></a>00081         <span class="keywordtype">void</span> writeInts(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a>* <span class="keyword">const</span> pInt, <span class="keywordtype">size_t</span> count); 
<a name="l00082"></a>00082         <span class="keywordtype">void</span> writeBools(<span class="keyword">const</span> <span class="keywordtype">bool</span>* <span class="keyword">const</span> pLong, <span class="keywordtype">size_t</span> count);
<a name="l00083"></a>00083         <span class="keywordtype">void</span> writeObject(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; vec);
<a name="l00084"></a>00084         <span class="keywordtype">void</span> writeObject(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; q);
<a name="l00085"></a>00085         
<a name="l00086"></a>00086         <span class="keywordtype">void</span> writeString(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <span class="keywordtype">string</span>);
<a name="l00087"></a>00087         <span class="keywordtype">void</span> writeData(<span class="keyword">const</span> <span class="keywordtype">void</span>* <span class="keyword">const</span> buf, <span class="keywordtype">size_t</span> size, <span class="keywordtype">size_t</span> count);
<a name="l00088"></a>00088         
<a name="l00089"></a>00089         <span class="keyword">virtual</span> <span class="keywordtype">void</span> readFileHeader(<a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a>&amp; stream);
<a name="l00090"></a>00090         <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> readChunk(<a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a>&amp; stream);
<a name="l00091"></a>00091         
<a name="l00092"></a>00092         <span class="keywordtype">void</span> readBools(<a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a>&amp; stream, <span class="keywordtype">bool</span>* pDest, <span class="keywordtype">size_t</span> count);
<a name="l00093"></a>00093         <span class="keywordtype">void</span> readFloats(<a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a>&amp; stream, <span class="keywordtype">float</span>* pDest, <span class="keywordtype">size_t</span> count);
<a name="l00094"></a>00094         <span class="keywordtype">void</span> readFloats(<a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a>&amp; stream, <span class="keywordtype">double</span>* pDest, <span class="keywordtype">size_t</span> count);
<a name="l00095"></a>00095         <span class="keywordtype">void</span> readShorts(<a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a>&amp; stream, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a>* pDest, <span class="keywordtype">size_t</span> count);
<a name="l00096"></a>00096         <span class="keywordtype">void</span> readInts(<a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a>&amp; stream, <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a>* pDest, <span class="keywordtype">size_t</span> count);
<a name="l00097"></a>00097         <span class="keywordtype">void</span> readObject(<a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a>&amp; stream, <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; pDest);
<a name="l00098"></a>00098         <span class="keywordtype">void</span> readObject(<a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a>&amp; stream, <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; pDest);
<a name="l00099"></a>00099 
<a name="l00100"></a>00100         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> readString(<a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a>&amp; stream);
<a name="l00101"></a>00101         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> readString(<a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a>&amp; stream, <span class="keywordtype">size_t</span> numChars);
<a name="l00102"></a>00102         
<a name="l00103"></a>00103         <span class="keyword">virtual</span> <span class="keywordtype">void</span> flipToLittleEndian(<span class="keywordtype">void</span>* pData, <span class="keywordtype">size_t</span> size, <span class="keywordtype">size_t</span> count = 1);
<a name="l00104"></a>00104         <span class="keyword">virtual</span> <span class="keywordtype">void</span> flipFromLittleEndian(<span class="keywordtype">void</span>* pData, <span class="keywordtype">size_t</span> size, <span class="keywordtype">size_t</span> count = 1);
<a name="l00105"></a>00105         
<a name="l00106"></a>00106         <span class="keyword">virtual</span> <span class="keywordtype">void</span> flipEndian(<span class="keywordtype">void</span> * pData, <span class="keywordtype">size_t</span> size, <span class="keywordtype">size_t</span> count);
<a name="l00107"></a>00107         <span class="keyword">virtual</span> <span class="keywordtype">void</span> flipEndian(<span class="keywordtype">void</span> * pData, <span class="keywordtype">size_t</span> size);
<a name="l00108"></a>00108 
<a name="l00110"></a>00110         <span class="keyword">virtual</span> <span class="keywordtype">void</span> determineEndianness(<a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a>&amp; stream);
<a name="l00112"></a>00112         <span class="keyword">virtual</span> <span class="keywordtype">void</span> determineEndianness(<a class="code" href="classOgre_1_1Serializer.html#a5122d5a3161fb5fd819d9a0521fe9d39" title="The endianness of written files.">Endian</a> requestedEndian);
<a name="l00113"></a>00113     };
<a name="l00117"></a>00117 }
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
